import { type PropType } from "vue";
import { type INodeItem } from ".";
declare const _sfc_main: import("vue").DefineComponent<{
    list: {
        type: PropType<any[]>;
        required: true;
    };
    parentType: {
        type: StringConstructor;
        default: string;
    };
}, {
    props: any;
    $emit: (event: "customAdd", ...args: any[]) => void;
    slots: Readonly<{
        [name: string]: import("vue").Slot;
    }>;
    dragDefaultOptions: {
        animation: number;
        group: string;
        disabled: boolean;
        put: boolean;
        ghostClass: string;
    };
    dragOptions: import("vue").ComputedRef<{
        animation: number;
        group: string;
        disabled: boolean;
        put: boolean;
        ghostClass: string;
    }>;
    handleClick: (element: INodeItem) => void;
    onCustomAdd: (element: INodeItem, list: INodeItem[], parentType: "Array" | "Object", params: any) => void;
    handleAddNode: (element: import("./type").ITempNode, list: INodeItem[], params: import("./type").IAddNodeParams) => void;
    handleCustomAdd: (element: INodeItem, list: INodeItem[], params: any) => void;
    handleMouseEnterItem: (element: INodeItem) => void;
    handleMouseLeaveItem: (element: INodeItem) => void;
    onMouseEnter: (element: INodeItem) => void;
    onMouseLeave: (element: INodeItem) => void;
    copyNodeItem: import("vue").Ref<{
        id: number;
        key: string;
        type: import("./type").INodeItemType;
        bg?: string;
        isKeyEditing?: boolean;
        isValueEditing?: boolean;
        showToolBar?: boolean;
        isShowBg?: boolean;
        hideChildren?: boolean;
        temp?: boolean;
        customData?: Object;
        children?: (any | {
            id: number;
            temp: boolean;
            key?: string;
            type?: import("./type").INodeItemType;
            bg?: string;
            isKeyEditing?: boolean;
            isValueEditing?: boolean;
            showToolBar?: boolean;
            isShowBg?: boolean;
            hideChildren?: boolean;
            customData?: Object;
            children?: (any | any)[];
            value?: string | number | boolean;
        })[];
        value?: string | number | boolean;
    } | {
        id: number;
        temp: boolean;
        key?: string;
        type?: import("./type").INodeItemType;
        bg?: string;
        isKeyEditing?: boolean;
        isValueEditing?: boolean;
        showToolBar?: boolean;
        isShowBg?: boolean;
        hideChildren?: boolean;
        customData?: Object;
        children?: (any | any)[];
        value?: string | number | boolean;
    }>;
    getToolBar: (type: import("./type").INodeItemType, copyItem: INodeItem) => string[];
    handleChooseTool: (type: string, element: INodeItem, parentList?: INodeItem[]) => void;
    handleEditKey: (element: INodeItem) => void;
    handleDeleteNode: (element: INodeItem, parent?: INodeItem[]) => void;
    handleDoubleClick: (...args: any[]) => void;
    readonly Draggable: import("vue").DefineComponent<{
        list: {
            type: ArrayConstructor;
            required: boolean;
            default: any;
        };
        modelValue: {
            type: ArrayConstructor;
            required: boolean;
            default: any;
        };
        itemKey: {
            type: (StringConstructor | FunctionConstructor)[];
            required: boolean;
        };
        clone: {
            type: FunctionConstructor;
            default: (original: any) => any;
        };
        tag: {
            type: StringConstructor;
            default: string;
        };
        move: {
            type: FunctionConstructor;
            default: any;
        };
        componentData: {
            type: ObjectConstructor;
            required: boolean;
            default: any;
        };
    }, unknown, {
        error: boolean;
    }, {
        realList(): any;
        getKey(): any;
    }, {
        getUnderlyingVm(domElement: any): any;
        getUnderlyingPotencialDraggableComponent(htmElement: any): any;
        emitChanges(evt: any): void;
        alterList(onList: any): void;
        spliceList(): void;
        updatePosition(oldIndex: any, newIndex: any): void;
        getRelatedContextFromMoveEvent({ to, related }: {
            to: any;
            related: any;
        }): any;
        getVmIndexFromDomIndex(domIndex: any): any;
        onDragStart(evt: any): void;
        onDragAdd(evt: any): void;
        onDragRemove(evt: any): void;
        onDragUpdate(evt: any): void;
        computeFutureIndex(relatedContext: any, evt: any): any;
        onDragMove(evt: any, originalEvent: any): any;
        onDragEnd(): void;
    }, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, any[], any, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<{
        move: Function;
        tag: string;
        clone: Function;
        list: unknown[];
        modelValue: unknown[];
        componentData: Record<string, any>;
    } & {
        itemKey?: string | Function;
    }>, {
        move: Function;
        tag: string;
        clone: Function;
        list: unknown[];
        modelValue: unknown[];
        componentData: Record<string, any>;
    }>;
    DefaultToolBar: import("vue").DefineComponent<{
        visible: {
            type: PropType<boolean>;
            default: boolean;
        };
        tools: {
            type: PropType<string[]>;
            default: () => any[];
        };
    }, {
        props: any;
        toolBars: import("vue").Raw<{
            name: string;
            component: any;
            event: string;
            tip: string;
            class: string;
        }[]>;
        toolList: import("vue").ComputedRef<{
            name: string;
            component: any;
            event: string;
            tip: string;
            class: string;
        }[]>;
        $emit: (event: "choose", ...args: any[]) => void;
        handleClick: (type: string) => void;
        readonly TTooltip: any;
    }, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, "choose"[], "choose", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        visible: {
            type: PropType<boolean>;
            default: boolean;
        };
        tools: {
            type: PropType<string[]>;
            default: () => any[];
        };
    }>> & {
        onChoose?: (...args: any[]) => any;
    }, {
        visible: boolean;
        tools: string[];
    }>;
    readonly CaretDownSmallIcon: any;
    readonly CaretRightSmallIcon: any;
    CascaderInput: import("vue").DefineComponent<{
        parentType: {
            type: StringConstructor;
            default: string;
        };
    }, {
        props: any;
        options: import("vue").Ref<any[]>;
        $emit: (event: "customAdd" | "delete" | "submit", ...args: any[]) => void;
        form: any;
        keyVisible: import("vue").ComputedRef<any>;
        valueVisible: import("vue").ComputedRef<any>;
        computedType: (type: string) => string;
        handleChangeType: () => void;
        handleDoubleClick: any;
        handleSelectType: (value: SelectValue) => void;
        handleSubmit: () => void;
        handleCustomSubmit: () => void;
        handleDelete: () => void;
        readonly TSelect: any;
        readonly TTag: any;
        readonly TButton: any;
        readonly TInput: any;
        readonly TForm: any;
        readonly TFormItem: any;
        InputField: import("vue").DefineComponent<{
            modelValue: {
                default: string;
            };
            type: {
                type: StringConstructor;
                default: string;
            };
            autoFocus: {
                type: PropType<boolean>;
                default: boolean;
            };
            blurFinish: {
                type: BooleanConstructor;
                default: boolean;
            };
        }, {
            props: any;
            $emit: (event: "update:modelValue" | "finish", ...args: any[]) => void;
            handleOperation: (value: any, type: "enter" | "blur") => void;
            handleChange: (value: any) => void;
            readonly TInput: any;
            readonly TInputNumber: any;
            readonly TSwitch: any;
        }, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, ("update:modelValue" | "finish")[], "update:modelValue" | "finish", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
            modelValue: {
                default: string;
            };
            type: {
                type: StringConstructor;
                default: string;
            };
            autoFocus: {
                type: PropType<boolean>;
                default: boolean;
            };
            blurFinish: {
                type: BooleanConstructor;
                default: boolean;
            };
        }>> & {
            "onUpdate:modelValue"?: (...args: any[]) => any;
            onFinish?: (...args: any[]) => any;
        }, {
            type: string;
            modelValue: string;
            autoFocus: boolean;
            blurFinish: boolean;
        }>;
        readonly CloseIcon: any;
    }, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, ("customAdd" | "delete" | "submit")[], "customAdd" | "delete" | "submit", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        parentType: {
            type: StringConstructor;
            default: string;
        };
    }>> & {
        onCustomAdd?: (...args: any[]) => any;
        onDelete?: (...args: any[]) => any;
        onSubmit?: (...args: any[]) => any;
    }, {
        parentType: string;
    }>;
    readonly TTag: any;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, "customAdd"[], "customAdd", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    list: {
        type: PropType<any[]>;
        required: true;
    };
    parentType: {
        type: StringConstructor;
        default: string;
    };
}>> & {
    onCustomAdd?: (...args: any[]) => any;
}, {
    parentType: string;
}>;
export default _sfc_main;
